<?php 

function wpforms_amocrm_process_complete( $fields_data, $entry, $form_data, $entry_id ) {
           
    $form_id = $entry['id'];
    $post_id = $entry['post_id'];

    $form_fields = get_post_meta( $form_id, 'wpforms-amocrm', 1 );

    if( isset($form_fields['status']) and $form_fields['status'] ){

        $settings = get_option('wpforms-amocrm');

        if(!isset($settings['time_zone']) ){
            $settings['time_zone'] = 'Europe/Moscow';
        }

        date_default_timezone_set($settings['time_zone']);

        $options = get_option('amocrm-wpforms-settings');
        $field_types = $options['field_types']; 
        $utms = isset($options['utm_fields']) ? $options['utm_fields'] : false;

        $responsible_user_id = (int)$form_fields['responsible_user_id'];
    
        $lead_name = $form_fields['lead_name'];
        $note = $form_fields['note'];
    
        $task_text = $form_fields['task']['task_text'];
    
        $page_name = get_the_title($post_id);
        $form_name = get_the_title($form_id);
        $page_url = get_option('home').'?p='.$post_id;
        $home_url = get_option('home');
        $date = date('d.m.Y');
        $time = date('H:i:s');   
        $ip = getIp_wpform_amocrm();
    
        require (__DIR__ . '/fields_default.php');

        foreach($custom_tags as $custom_tag){
            $lead_name = str_replace('{{'.$custom_tag.'}}', ${$custom_tag}, $lead_name);
            $note = str_replace('{{'.$custom_tag.'}}', ${$custom_tag}, $note);
    
            $custom_tag_value = $form_fields['custom_tags'][$custom_tag]; // !!!!!!!!!
    
            if($custom_tag_value !== '0' and $custom_tag_value !== ''){
                $_data = explode('-', $custom_tag_value);
                $entry = $_data['0'];
                $field_id = $_data['1'];
                $field_type = 'text';
                if(isset($field_types[$entry][$field_id])){
                    $field_type = $field_types[$entry][$field_id];
                }
    
                if( in_array($field_type, ['date_time', 'birthday', 'date']) ){
                    $form_value = strtotime(${$custom_tag});
                }elseif( in_array($field_type, ['checkbox']) ){
                    $form_value = ${$custom_tag} ? true : false;
                }else{
                    $form_value = (string)${$custom_tag};
                }
    
                if($form_value === '' or $form_value === null){
                    continue;
                }
                
                if($field_id === 'price'){
                    $form_value = (int)$form_value;
                }
    
                if( in_array($field_id, ['price', 'name', 'first_name', 'last_name']) ){
                    $entryes[$entry][$field_id] = $form_value;
                }else{
    
                    if(is_array(${$custom_tag})){
                        $values = [];
                        foreach(${$custom_tag} as $fv){
                            $values[] = ['value' => $fv];
                        }
                        $entryes[$entry]['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => $values
                        ];
                    }else{
                        $entryes[$entry]['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => [
                                [
                                    'value' => $form_value
                                ]
                            ]
                        ];
                    }
                }
            }
        }


        foreach($fields_data as $field){
            $key = isset($form_fields['fields'][$field['id']]) ? $form_fields['fields'][$field['id']] : false;
            if($key !== '0' and $key !== ''){
                $_data = explode('-', $key);
                $entry = $_data['0'];
                $field_id = $_data['1'];
    
                $field_type = 'text';
    
                if(isset($field_types[$entry][$field_id])){
                    $field_type = $field_types[$entry][$field_id];
                }
    
                if( in_array($field_type, ['date_time', 'birthday', 'date']) ){
                    $form_value = strtotime($field['value']);
                }elseif( in_array($field_type, ['checkbox']) ){
                    $form_value = $field['value'] ? true : false;
                }else{
                    $form_value = (string)$field['value'];
                }
    
                if($form_value === '' or $form_value === null){
                    continue;
                }

                if($field_id === 'price'){
                    $form_value = (int)$form_value;
                }
    
                if( in_array($field_id, ['price', 'name', 'first_name', 'last_name']) ){
                    $entryes[$entry][$field_id] = $form_value;
                }else{
    
                    if(is_array($field['value'])){
                        $values = [];
                        foreach($field['value'] as $fv){
                            $values[] = ['value' => $fv];
                        }
                        $entryes[$entry]['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => $values
                        ];
                    }else{
                        $entryes[$entry]['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => [
                                [
                                    'value' => $form_value
                                ]
                            ]
                        ];
                    }
                }
            }

            $note = str_replace('{{'.$field['name'].'}}', $field['value'], $note);
            $lead_name = str_replace('{{'.$field['name'].'}}', $field['value'], $lead_name);     
            $task_text = str_replace('{{'.$field['name'].'}}', $field['value'], $task_text);   
        }

        if($lead_name){
            $entryes['lead']['name'] = $lead_name;
        }
    
        if($responsible_user_id){
            $entryes['lead']['responsible_user_id'] = $responsible_user_id;
        }

        if($form_fields['price']){
            $entryes['lead']['price'] = (int)$form_fields['price'];
        } 
    
        if($utms){
            foreach($utms as $field_id => $utm){
                if (isset($_COOKIE[$utm])) {
                    $entryes['lead']['custom_fields_values'][] = [
                        'field_id' => (int)$field_id,
                        'values' => [
                            [
                                'value' => (string)$_COOKIE[$utm]
                            ]
                        ]
                    ];
                }
            }
        }

        $entryes['task'] = [];
        if( $form_fields['task']['task_status'] == 1 ){
            $task_type = $form_fields['task']['task_type'];
            
            foreach($custom_tags as $custom_tag){
                $task_text = str_replace('{{'.$custom_tag.'}}', ${$custom_tag}, $task_text);
            }

            $task_complete_till = $form_fields['task']['task_complete_till'];
            $task_complete_till_times = $form_fields['task']['task_complete_till_times'];
            $current_datetime = date('Y-m-d H:i:s');
            $task_complete_till = strtotime($current_datetime . ' +' . $task_complete_till . ' ' . $task_complete_till_times );
            $entryes['task'] = [
                'task_type_id' => (int)$task_type,
                'text' => $task_text,
                'complete_till' => (int)$task_complete_till

            ];

            if($responsible_user_id){
                $entryes['task']['responsible_user_id'] = $responsible_user_id;
            }
        }

        $pipeline_id = (int)$form_fields['pipeline_id'];
        $p_status = $form_fields['p_status'];
        $price = $form_fields['price'];

        $entryes['lead']['name'] = $lead_name;

        $unsortered = strpos($p_status, 'unsortered_');

        // если неразобранное
        if($unsortered !== false){
            $entryes['source_name'] = get_option('blogname');
            $entryes['source_uid'] = md5(microtime(true).'devamo.ru');
            if($pipeline_id){
                $entryes['pipeline_id'] = $pipeline_id;
            }
            
        }else{
            // если разобранное
            $entryes['lead']['status_id'] = (int)$p_status;
            $entryes['lead']['pipeline_id'] = $pipeline_id;
        }

        if($price){
            $entryes['lead']['price'] = (int)$price;
        }           

        if($form_fields['tags']){
            foreach($form_fields['tags'] as $tag){
                foreach($custom_tags as $custom_tag){
                    $tag = str_replace('{{'.$custom_tag.'}}', ${$custom_tag}, $tag);
                }
                if(empty($tag)){
                    continue;
                }
                $entryes['lead']['_embedded']['tags'][] = ['name' => $tag];
            }
        }

        if(isset($entryes['contact']) and $responsible_user_id){
            $entryes['contact']['responsible_user_id'] = $responsible_user_id;
        }

        if(isset($entryes['company']) and $responsible_user_id){
            $entryes['company']['responsible_user_id'] = $responsible_user_id;
        }

        $entryes['note'] = $note;
        $entryes['ip'] = $ip;
        $entryes['antidub'] = $form_fields['antidub'];
        
        if($unsortered !== false){
            $entryes['request_id'] = (string)time();

            if($entryes['lead']){
                $entryes['_embedded']['leads'][] = $entryes['lead'];
                unset($entryes['lead']);
            }

            if($entryes['contact']){
                $entryes['_embedded']['contacts'][] = $entryes['contact'];
                unset($entryes['contact']);
            }

            if($entryes['company']){
                $entryes['_embedded']['companies'][] = $entryes['company'];
                unset($entryes['company']);
            }

            $entryes['metadata'] = [
                'ip' => $ip,
                'form_id' => $form_id,
                'form_sent_at' => (int)time(),
                'form_name' => $form_name,
                'form_page' => $page_url,
            ];

            unset($entryes['note']);
            unset($entryes['antidub']);
            unset($entryes['antidub_lead']);
            unset($entryes['task']);
            unset($entryes['salesbot']);
            unset($entryes['notify']);
            unset($entryes['ip']);

            $data['action'] = 'unsortered';
        }else{
            $data['action'] = 'WPFORMS';
        }

        $data['data'] = json_encode($entryes);      
        $data['url'] = $_SERVER['HTTP_HOST'];

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_URL, 'https://devamo.ru/wpforms/ajax');
        curl_setopt($curl, CURLOPT_HEADER, false);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
        $output = curl_exec($curl);

    } 
}
add_action( 'wpforms_process_complete', 'wpforms_amocrm_process_complete', 10, 4 );

function getIp_wpform_amocrm(){
    $client  = isset($_SERVER['HTTP_CLIENT_IP']) ? $_SERVER['HTTP_CLIENT_IP'] : false;
    $forward = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : false;
    $remote  = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : $_SERVER['REMOTE_ADDR'];
    if(filter_var($client, FILTER_VALIDATE_IP)){
        $ip = $client;
    }elseif(filter_var($forward, FILTER_VALIDATE_IP)){
        $ip = $forward;
    }else{
        $ip = $remote;
    }
    return $ip;
}

function get_wpform($form_id){
    global $wpdb;
    $form = $wpdb->get_row( "SELECT ID, post_title, post_date, post_content FROM $wpdb->posts WHERE ID = '".$form_id."' AND post_type = 'wpforms' AND post_status = 'publish'", 'ARRAY_A' );
    $form['post_date'] = date('d.m.Y', strtotime($form['post_date']));
    $form['fields'] = json_decode($form['post_content'], true)['fields'];
    unset($form['post_content']);
    return $form;
}

function get_wpforms(){
    global $wpdb;
    $forms = $wpdb->get_results( "SELECT ID, post_title, post_date, post_content FROM $wpdb->posts WHERE post_type = 'wpforms' AND post_status = 'publish'", 'ARRAY_A' );
    foreach ( $forms as $key => $form ) {
        $forms[$key]['post_date'] = date('d.m.Y', strtotime($form['post_date']));
        $forms[$key]['fields'] = json_decode($form['post_content'], true)['fields'];
        unset($forms[$key]['post_content']);
    }
    return $forms;
}

function getAmoWpform($clear_cache = 0){
    $data = [
        'action' => 'getAmoCF',
        'url' => $_SERVER['HTTP_HOST'], 
        'companies' => true,
        'clear' => $clear_cache,
    ];
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_URL, 'https://devamo.ru/wpforms/ajax');
    curl_setopt($curl, CURLOPT_HEADER, false);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
    $output = curl_exec($curl);
    curl_close($curl);
    $output = json_decode($output, true);
	if(isset($output['status']) and $output['status']){
        update_option( 'amocrm-wpforms-settings', $output['settings'] );
	}
	return isset($output['settings']) ? $output['settings'] : false;
}

function amocrm_wpforms() {
	add_options_page('Интеграция WpForms с amoCRM', 'Интеграция WpForms с amoCRM', 'manage_options', 'amocrm_wpf', 'amocrm_wpforms_settings_page');
}

function amocrm_wpforms_settings_page(){
	require_once (__DIR__ . '/admin.php');;
}

function save_utm_to_cookie() {
    $date = time()+3600*24*30;
    $options = get_option('amocrm-wpforms-settings');
    $utms = isset($options['utm_fields']) ? $options['utm_fields'] : false;
    if($utms){
        foreach($utms as $utm){
            if(isset($_GET[$utm])) setcookie($utm, $_GET[$utm], $date, "/"); 
        }
    }
}

function wpforms_amocrm_deactivate(){
    delete_option('wpforms-amocrm');
    delete_option('amocrm-wpforms-settings');
}

function wpforms_amocrm_activate(){
    if( !getAmoWpform() ){
        exit('Сайт '.$_SERVER['HTTP_HOST'].' не добавлен в настойках виджета amoCRM! <br>Перейдите в amoCRM, выберите в меню слева Настройки > Интеграции, затем найдите "Wordpress WpForms" и кликните по нему, во всплывающем окне добавьте свой сайт в соответвующее поле.<br>Техническая поддержка amo@devamo.ru или телеграм @bmite');
    }
}

add_filter('plugin_action_links', 'wpforms_amocrm_links', 10, 2);
function wpforms_amocrm_links($actions, $plugin_file ) {
	if( false === strpos( $plugin_file, 'wpforms-amocrm' ) ){
        return $actions;
    }
	$settings_link = '<a href="/wp-admin/options-general.php?page=amocrm_wpf' .'">Настройки</a>'; 
	array_unshift( $actions, $settings_link ); 
	return $actions; 
}

function wpforms_amocrm_scripts( $hook_suffix ) {
	if ( false === strpos( $hook_suffix, 'amocrm_wpf' ) ) {
		return;
	}
	wp_enqueue_script('amocrm_wpf', plugins_url( 'wpforms-amocrm/js/main.js' ), '', filemtime( __DIR__ . ('/js/main.js') ) ,true);
    wp_enqueue_style( 'amocrm_wpf', plugins_url( 'wpforms-amocrm/css/main.css' ), null, filemtime( __DIR__ . ('/css/main.css') ), 'all' );

}